#pragma once

#include "CoreMinimal.h"
#include "Components/ActorComponent.h"
#include "K37SurvivorScentTrailParticleSpawner.generated.h"

class UAuthoritativeActorPoolComponent;
class UK37WolfAbility;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class THEK37_API UK37SurvivorScentTrailParticleSpawner : public UActorComponent
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced, meta=(AllowPrivateAccess=true))
	UAuthoritativeActorPoolComponent* _authoritativeScentParticlePool;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Replicated, Export, meta=(AllowPrivateAccess=true))
	TWeakObjectPtr<UK37WolfAbility> _wolfAbility;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, ReplicatedUsing=OnRep_ScentParticleSpawnTimerRemainingTime, meta=(AllowPrivateAccess=true))
	float _scentParticleSpawnTimerRemainingTime;

private:
	UFUNCTION(BlueprintCallable)
	void OnRep_ScentParticleSpawnTimerRemainingTime() const;

	UFUNCTION(BlueprintCallable)
	void Authority_OnIsRunningAndMovingChanged(const bool isRunningAndMoving);

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UK37SurvivorScentTrailParticleSpawner();
};

FORCEINLINE uint32 GetTypeHash(const UK37SurvivorScentTrailParticleSpawner) { return 0; }
